Subject: Re: [PATCH] bonding: Offloading bonds to hardware

From: John Fastabend <[email-masked]>
Date: Sat, 14 Nov 2015 21:51:28 -0800

On 15-11-14 01:39 AM, Jiri Pirko wrote:
> Thu, Nov 12, 2015 at 05:02:18PM CET, [email-masked] wrote:
>> Packet forwarding to/from bond interfaces is done in software.
>>
>> This patch enables certain platforms to bridge traffic to/from
>> bond interfaces in hardware.  Notifications are sent out when 
>> the "active" slave set for a bond interface is updated in 
>> software.  Platforms use the notifications to program the 
>> hardware accordingly.  The changes have been verified to work 
>> with configured and 802.3ad bond interfaces.
>>
>> Signed-off-by: Premkumar Jonnala <[email-masked]>
> 
> This patch is wrong, in many different acpects. Leaving the submission
> style, and no in-tree consumer aside, adding ndos for this thing is
> unacceptable. It should be handled as a part of switchdev attrs.

Why is it unacceptable? I think its at least worth debating. If I
have a nic that can do bonding but none of the other switchdev
things then implementing another ndo is certainly more straight
forward. As it is heading many of the 10+Gbps nics may need to
implement just enough of the switchdev infrastructure to get things
like bonding up and working. Not necessarily a bad thing if we make
the switchdev infrastructure light but does sort of make the name
confusing if my nic is not doing any switching ;)

Thanks,
John

> Also, the solution should not be bonding-centric.
> 
> I have a patchset in my queue which does this correctly, for bond and team
> using switchdev attr and with actual in-tree consumer, mlxsw driver.
> I plan to send that soon after net-next opens.
> 
> Jiri
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>